﻿	/**
	* ...
	* @author Written by Charles Palen with help from the Red5 Community Examples for a 
	* webcam stream recorder
	*/
package org.red5.as3.net {
	import flash.events.EventDispatcher;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import org.red5.as3.net.events.ConnectionEvent;
	
	public class  Recorder extends EventDispatcher {
		// Data members
		private var ns:NetStream;
		
		// Constants for outside event listeners
		public static var ISRECORDING:String = "isrecording";
		public static var ISNOTRECORDING:String = "isnotrecording";
		public var HASSTREAM:Boolean = false;
		
		// Class Constructor
		public function Recorder() 
		{
			
		}
		
		public function InsertStream(IncomingNetStream:NetStream):void
		{
			// Assumes the camerea is already attached to this stream and that
			// a NetConnection has already been made
			ns = IncomingNetStream;
		}
		
		public function SetStreamStatus(Status:Boolean):void
		{
			HASSTREAM = Status;
		}
		
		public function getNetStream():NetStream
		{
			return ns;
		}
		
		public function StartRecording():void
		{
			// Create a new date object
			var CurrentDate:Date = new Date();
			var FourDigYear:uint = CurrentDate.getFullYear();
			var Month:uint = CurrentDate.getMonth();
			var Day:uint = CurrentDate.getDay();
			var Hour:uint = CurrentDate.getHours();
			var Minutes:uint = CurrentDate.getMinutes();
			var Seconds:uint = CurrentDate.getSeconds();
			
			var TimeComponent:String = String(FourDigYear) + String(Month) + String(Day) + String(Hour) + String(Minutes) + String(Seconds);
			
			// Publish the net stream
			ns.publish("SecStream" + TimeComponent , "record");
			
			var e:ConnectionEvent = new ConnectionEvent(Recorder.ISRECORDING, false, false, "Make shift manual event for StartRecording");
			dispatchEvent(e);
		}
		
		public function StopRecording():void
		{
			// Close the next ream
			ns.close();
			
			var e:ConnectionEvent = new ConnectionEvent(Recorder.ISNOTRECORDING, false, false, "Make shift manual event for StopRecording");
			dispatchEvent(e);
		}
		
	}
	
}